From 6a1814a8b0d7189b397790b90fb5a6979a6b66cb Mon Sep 17 00:00:00 2001
From: Dmitry Logvinenko <dmlogv@gmail.com>
Date: Thu, 15 Jun 2023 19:47:51 +0300
Subject: [PATCH] lisp/org-habit.el: Inherit habit style property

* lisp/org-habit.el (org-is-habit-p):  Use `org-entry-get' with
'selective option to optionally find habit subheadings.
* etc/ORG-NEWS: Describe a breaking change.

TINYCHANGE
---
 etc/ORG-NEWS      | 15 +++++++++++++++
 lisp/org-habit.el |  2 +-
 2 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/etc/ORG-NEWS b/etc/ORG-NEWS
index 01d2975d3..cb4bc632b 100644
--- a/etc/ORG-NEWS
+++ b/etc/ORG-NEWS
@@ -74,6 +74,20 @@ the iCalendar spec demands a start date, and
 To revert to the old behavior, set
 ~org-icalendar-todo-unscheduled-start~ to ~current-datetime~.
 
+*** =org-habit.el= now optionally inherits ~:STYLE: habit~ properties
+
+Currently, the ~STYLE~ property of habits is not inherited when searching
+for entries.
+
+This change allows the property to be inherited optionally by customizing
+the ~org-use-property-inheritance~ variable.
+
+This change aims to provide more flexibility in managing habits, allowing
+users to dedicate separate subtrees or files to habits without manually
+setting the ~STYLE~ property for each sub-task.
+
+The change is breaking when ~org-use-property-inheritance~ is set to ~t~.
+
 ** New and changed options
 *** Commands affected by ~org-fold-catch-invisible-edits~ can now be customized
 
@@ -556,6 +570,7 @@ After:
 : ("simple" "list")
 #+end_src
 
+
 ** New features
 *** Clock table can now produce quarterly reports
 
diff --git a/lisp/org-habit.el b/lisp/org-habit.el
index ea935fe7c..b7ba6e349 100644
--- a/lisp/org-habit.el
+++ b/lisp/org-habit.el
@@ -170,7 +170,7 @@ means of creating calendar-based reminders."
 
 (defun org-is-habit-p (&optional pom)
   "Is the task at POM or point a habit?"
-  (string= "habit" (org-entry-get (or pom (point)) "STYLE")))
+  (string= "habit" (org-entry-get (or pom (point)) "STYLE" 'selective)))
 
 (defun org-habit-parse-todo (&optional pom)
   "Parse the TODO surrounding point for its habit-related data.
-- 
2.40.1

